import { ContractOverrides, IMinimalForwarderContract, IMinimalForwarderRequest, WrappedTransactionResponse } from "../interfaces";
import { EVMAccountAddress, EVMContractAddress, MinimalForwarderContractError, BigNumberString, Signature } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
export declare class MinimalForwarderContract implements IMinimalForwarderContract {
    protected providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet;
    protected contract: ethers.Contract;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet, contractAddress: EVMContractAddress);
    getNonce(from: EVMAccountAddress): ResultAsync<BigNumberString, MinimalForwarderContractError>;
    verify(request: IMinimalForwarderRequest, signature: Signature): ResultAsync<boolean, MinimalForwarderContractError>;
    execute(request: IMinimalForwarderRequest, signature: Signature, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, MinimalForwarderContractError>;
    getContract(): ethers.Contract;
    protected writeToContract(functionName: string, functionParams: any[], overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, MinimalForwarderContractError>;
    protected toWrappedTransactionResponse(transactionResponse: ethers.providers.TransactionResponse, functionName: string, functionParams: any[]): WrappedTransactionResponse;
}
//# sourceMappingURL=MinimalForwarderContract.d.ts.map