"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WrappedTransactionResponseBuilder = void 0;
const index_js_1 = require("../interfaces/objects/index.js");
const inversify_1 = require("inversify");
let WrappedTransactionResponseBuilder = class WrappedTransactionResponseBuilder {
    static buildWrappedTransactionResponse(transactionResponse, contractAddress, signerAddress, functionName, functionParams, contractAbi) {
        return new index_js_1.WrappedTransactionResponse(transactionResponse, contractAddress, signerAddress, functionName, JSON.stringify(functionParams || []), this.extractFunctionAbi(functionName, contractAbi));
    }
    static extractFunctionAbi(functionName, contractAbi) {
        if (contractAbi == null || contractAbi.abi instanceof Array === false) {
            return "";
        }
        for (const item of contractAbi.abi) {
            if (item.type === "function" && item.name === functionName) {
                return item;
            }
        }
        return "";
    }
};
WrappedTransactionResponseBuilder = __decorate([
    (0, inversify_1.injectable)()
], WrappedTransactionResponseBuilder);
exports.WrappedTransactionResponseBuilder = WrappedTransactionResponseBuilder;
//# sourceMappingURL=WrappedTransactionResponseBuilder.js.map