import { RewardsFactoryError, BaseURI } from "@snickerdoodlelabs/objects";
import { ResultAsync } from "neverthrow";
import { ethers } from "ethers";
import { ContractOverrides, WrappedTransactionResponse } from "../interfaces/objects";
export interface IRewardsContractFactory {
    deployERC721Reward(name: string, symbol: string, baseURI: BaseURI, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, RewardsFactoryError>;
    estimateGasToDeployERC721Contract(name: string, symbol: string, baseURI: BaseURI): ResultAsync<ethers.BigNumber, RewardsFactoryError>;
}
export declare const IRewardsContractFactoryType: unique symbol;
//# sourceMappingURL=IRewardsContractFactory.d.ts.map